#!/usr/bin/perl -U
# ************************************************
#
#      Web Dialer v1.3 by Dietrich Heise
#          dietrich@pegestorf.de
#
#     http://www.pegestorf.de/webwvdial/
#
# im cgi Verzeichnis werden die Dateien 
# online.log, online.dat und provider.dat 
# ip.dat erzeugt
# ************************************************
# Edit this

$config_file = "webdial.conf";

# END OF CONFIG
# ************************************************

use CGI qw/:standard/;
use Time::Local;
use AppConfig;

my $configure = AppConfig->new(
    {
	GLOBAL=>{ ARGCOUNT => 1 }
    },
    'baseURL','htmlDIR','baseCGI','skript',
    'dev','notallowed','configpass','logpass',
    'adminpass','bgcolor','bordercolor',
    'titlecolor','tablecolor','colorconnect',
    'colordeconnect','passwordcolor',
    'gesamtcolor','varlogbuttons',
    'loglines','allowshutdown','refreshtime',
    'timezone','language','standardlogdays',
    'type','dialcommand','isdnip',
    'deconnectcommand','errorlog',
    'messageslog','webdialpid','webdialpid2',
    'seconds','secondskript','thirdskript',
    'run_dialin','run_dialout'
);

$configure->file($config_file);

&english;

if ($configure->language() eq "german") {&german;}
if ($configure->language() eq "english") {&english;}
if ($configure->language() eq "french") {&francais;}
if ($configure->language() eq "spanish") {&spanish;}
if ($configure->language() eq "italian") {&italian;}
if ($configure->language() eq "czech") {&czech;}
if ($configure->language() eq "turkish") {&turkish;}

if ($configure->notallowed() ne ""){
  if ($configure->notallowed() =~ /:/){
    @notallow = split /:/,$configure->notallowed();
  }else{
    @notallow[0]=$configure->notallowed();
  }
}

$myip = remote_addr();  #IP des Rechners herausfinden

&allowed;
&online;
&wann;
if (!(((param('status')) eq "startppp") || ((param('status')) eq "startppp2"))){
  &ifpppdown;
}

# Shutdown ***************************************
if (((param('status')) eq "halt") && ($configure->allowshutdown())){&halt;}
# Startppp ***************************************
elsif ((param('status')) eq "startppp"){&startppp;}
# Connecting *************************************
elsif ((param('status')) eq "startppp2"){&startppp2;}
# Stopppp ****************************************
elsif ((param('status')) eq "stopppp"){&stopppp;}
# Config *****************************************
elsif ((param('status')) eq "config"){&config;}
# Logdatei ***************************************
elsif ((param('status')) eq "log"){&logs;}
# Status *****************************************
elsif ((param('status')) eq "stat"){&status;}
# Messages ***************************************
elsif (((param('status')) eq "messages") && ($configure->varlogbuttons())){&messages;}
# Http Errors ************************************
elsif (((param('status')) eq "httpe") && ($configure->varlogbuttons())){&httpe;}
# Sollte nicht vorkommen *************************
elsif (param('status')) {
    print header;
    print "<BODY BGCOLOR=\"".$configure->bgcolor()."\">\nStatus = ".param('status')."\n</BODY>\n</HTML>";
}
# Startseite *************************************
else {
    &buttons($message[0]);
    &onlinestat;
    &configure;
    @pppaddr = `/sbin/ifconfig`;
    foreach $addr (@pppaddr){
      my $dev = $configure->dev();
      if(($addr =~ /$dev/) && ($configure->type() ne 2)){
        &printFound;
      }
    }
    if ($configure->type() eq 2) {
      $isdn = 1;
      if ($configure->isdnip()){
        foreach $addr (@pppaddr){
          my $isdnip = $configure->isdnip();
	  if($addr =~ /$isdnip/){
            $isdn = 0;
          }
        }
      }
      if ($isdn) {&printFound;}
    }
    print end_html;
}
exit;
# ************************************************
sub buttons{
    print header;
    print "<HTML>\n<HEAD>\n<TITLE>".@_[0]."</TITLE>\n</HEAD>\n";
    print "<BODY BGCOLOR=\"".$configure->bgcolor()."\">\n";
    print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
    print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n";
    &by;
    print "</CENTER></TD></TR><TR BGCOLOR=\"".$configure->tablecolor()."\"><TD>";
    print "<TABLE CELLPADDING=\"0\" cellspacing=\"0\" border=\"0\">\n<TR>\n";
	&pppbutton;
	&haltbutton;
	if ($configure->type() eq "0") {&configbutton;}
	&logbutton;
	&statusbutton;
	&infobutton;
	if ($configure->varlogbuttons()){
	  &messagesbutton;
	  &httpebutton;
	}
    print "</TR>\n</TABLE>\n";
    print "</TD></TR>\n";
    print "</TABLE></TD></TR></TABLE><BR>";

    print "\t<!-- Ende der Buttonleiste -->\n";
}
sub pppbutton{
    &online;
    if ($istonline == 1){
	&stoppppbutton;
    }
    else{
	&startpppbutton;
    }
}
sub startpppbutton{
  print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"startppp\">\n";
  print "<INPUT type=submit name=submit value=\"$message[1]\">\n";
  print "</FORM>\n</TD>\n";
}
sub stoppppbutton{
  print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"stopppp\">\n";
  print "<INPUT type=submit name=submit value=\"$message[2]\">\n";
  print "</FORM>\n</TD>\n";
}
sub haltbutton{
  if ($configure->allowshutdown()){ 
    if (!(@online)){
      print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
      print "<INPUT type=hidden name=\"status\" value=\"halt\">\n";
      print "<INPUT type=submit name=submit value=\"$message[3]\">\n";
      print "</FORM>\n</TD>\n";
    }
  }
}
sub configbutton{
  if (param('status') ne "config"){
    print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
    print "<INPUT type=hidden name=\"status\" value=\"config\">\n";
    print "<INPUT type=submit name=submit value=\"$message[4]\">\n";
    print "</FORM>\n</TD>\n";
  }
}
sub logbutton{
  print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"log\">\n";
  print "<INPUT type=submit name=submit value=\"$message[5]\">\n";
  print "</FORM>\n</TD>\n";
}
sub statusbutton{
  print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"stat\">\n";
  print "<INPUT type=submit name=submit value=\"$message[6]\">\n";
  print "</FORM>\n</TD>\n";
}
sub infobutton{
  print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
  print "<INPUT type=submit name=submit value=\"$message[7]\">\n";
  print "</FORM>\n</TD>\n";
}
sub onlinestat{
  &online;
  print "\t<!-- Begin des Onlinestatus -->\n";
  print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
  print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD>\n<CENTER><B>$message[8]</B></CENTER>\n";
  print "</TD>\n</TR>\n<TR>";
  print "<TD>";
  foreach $online (@online){
    @inhalt = split(/\e/,$online);
    $ip = $inhalt[0];
    print "&nbsp;".$ip."<BR>\n";
  }
  if (!(@online)){
    print "&nbsp;$message[9]<BR>\n";
  }
  print "</TD></TABLE></TD></TR></TABLE><BR>";

  #print "<HR>\n";
  #print "<H1>$message[8]</H1>\n";
  #foreach $online (@online){
#    @inhalt = split(/\e/,$online);
#    $ip = $inhalt[0];
#    print "&nbsp;".$ip."<BR>\n";
#  }
#  if (!(@online)){
#    print "&nbsp;$message[9]<BR>\n";
#  }
  print "\t<!-- Ende des Onlinestatus -->\n";
  
}
sub configure{
  print "\t<!-- Begin Configure -->\n";
  print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
  print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD>\n<CENTER><B>";
  
  
  if ($configure->type() eq "0"){
    open (config, "</etc/wvdial.conf");
      @config = <config>;
    close config;
    chop @config;
    foreach $config (@config){
      if ($config =~ /Username/){
        $config  =~ s/(Username = )//;
        $username = $config;
      }
      elsif ($config =~ /Password/){
        $config =~ s/(Password = )//;
        $password = $config;
      }
      elsif ($config =~ /Phone/){
        $config =~ s/(Phone = )//;
        $phone = $config;
      }
      elsif ($config =~ /Provider/){
        $config =~ s/(Provider = )//;
        $provider = $config;
      }
    } 
    print "$message[10]</B></CENTER>\n";
    print "</TD>\n</TR>\n<TR>";
    print "<TD>";
    print "<TABLE>\n";
    if ($configure->type() ne 2){
      print "<TR>\n<TD>$message[11]</TD>\n<TD><B>".$provider."</B></TD>\n</TR>\n";
      print "<TR>\n<TD>$message[12]&nbsp;</TD>\n<TD><B>".$phone."</B></TD>\n</TR>\n";
    }else{
      print "<TR>\n<TD>ISDN</TD>\n</TR>\n";
    }
    #print "<TR>\n<TD>$message[13]</TD>\n<TD><B>".$username."</B></TD>\n</TR>\n";  #Kann bei Internet-by-Surf auskommentiert werden
    #print "<TR>\n<TD>$message[14]</TD>\n<TD><B>".$password."</B></TD>\n</TR>\n";
    print "</TABLE>\n<BR>\n";
    &bytes(1);	
  }else{
    print "$message[40]</B></CENTER>\n";
    print "</TD>\n</TR>\n<TR>";
    print "<TD>";
    &bytes(1);
  }
  print "</TD></TR></TABLE></TD></TR></TABLE><BR>";
  print "\t<!-- Ende Configure -->\n";
}
# ************************************************
sub wann{
  if ($_[0]){
    $time = $_[0];
  }else{
    $time = time;
  }
  ($sec, $min, $std, $tag, $mon, $jahr) = localtime($time);
  $sec = &zs($sec);
  $min = &zs($min);
  $std = &zs($std);
  $tag = &zs($tag);
  $mon = &zs(++$mon);
  $jahr = $jahr + 1900;
  $datum = $tag.".".$mon.".".$jahr." ".$std.":".$min.":".$sec;
}
sub zs{
  if (length ($_[0]) < 2 ){
    return "0".$_[0];
  }else{
    return $_[0];
  }
}
# * Welche IP's schon online gemeldet sind *******
sub online{
  open (online, "<online.dat");
    @online = <online>;
  close (online);
  chop @online;
  $istonline = 0;
  foreach $line (@online){
    my @inhalt = split(/\e/,$line);
    $ip = $inhalt[0];
    if ($myip eq $ip) {
      $istonline = 1;
      # Dieser Rechner ist schon online 
    }
  }
}
# Rechner runterfahren ***************************
sub halt{
  print header;
  print "<BODY BGCOLOR=\"".$configure->bgcolor()."\">\n<H1>$message[15]</H1>\n";
  print end_html;
  `/sbin/halt`;
}
sub startppp{
  &online;
  if ($istonline){
    &error($message[16]);
    exit;
  }
  undef $found;
    @pppaddr = `/sbin/ifconfig`;
    foreach $addr (@pppaddr){
      my $dev = $configure->dev();
      if (($addr =~ /$dev/) && ($configure->type() ne 2)){
          $found = 1;
      }
    }
    if ($configure->type() eq 2) {
      $found = 1;
      if ($configure->isdnip()){
        foreach $addr (@pppaddr){
          my $isdnip = $configure->isdnip();
	  if($addr =~ /$isdnip/){
            $found = 0;
          }
        }
      }
    }
    open (LOG, ">>online.log");
    print LOG $myip."\e1\e".$datum."\e".$time;
    my $next = 0;
    open (pid, "<".$configure->webdialpid2()) || ($next = 1);
    if ($next = 0){
      $pid = <pid>;
      close (pid);
      system ("kill", "$pid");
      system ("rm",$configure->webdialpid2());
    }
    my $thirdskript = $configure->thirdskript();
    system("$thirdskript &");
    close (LOG);
    open (ONLINE, ">online.dat");
    print ONLINE $myip."\e".$time."\n";
    foreach $ip (@online){
      if (($myip."\e".$time) ne $ip){
        print ONLINE $ip."\n";
      }
    }
    close (ONLINE);
    open (traffic, "<traffic.log");
      @traffic = <traffic>;
    close (traffic);
    $help = $traffic[-1];
    $help = substr($help,-1,1);
    if ($help ne "\e"){
      open (traffic, ">>traffic.log");
        print traffic $time."\e";
      close (traffic);
    }
    undef @traffic;
    undef $help;
    if ($found){
      system($configure->run_dialin()." &");
      &online;
      &buttons($message[17]);
      &printFound;
      #&logbuttons;
    }else{
      if ($configure->refreshtime()){
        print redirect($configure->baseURL().$configure->baseCGI()."/".$configure->skript()."?status=startppp2");
      }else{
        print redirect($configure->baseURL().$configure->baseCGI()."/".$configure->skript()."?status=");
      }
      if (($configure->type() eq "1") || ($configure->type() eq "2")) {
        system($configure->dialcommand());
      }else{
        system("wvdial&");
      }
      my $secondskript = $configure->secondskript();
      system("$secondskript &"); 
    }
}
sub startppp2{
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    my $dev = $configure->dev();
    if(($addr =~ /$dev/) && ($configure->type() ne 2)){
      $found = 1;
    }
  }
  if ($configure->type() eq 2) {
    $found = 1;
    if ($configure->isdnip()){
      foreach $addr (@pppaddr){
        my $isdnip = $configure->isdnip();
        if($addr =~ /$isdnip/){
          $found = 0;
        }
      }
    }
  }
  if ($found){
    system($configure->run_dialin()." &");
    &buttons($message[17]);
    &printFound;
    #&logbuttons;
  }else{
    print header;
    print "<HTML>\n<HEAD>\n<TITLE>$message[18]</TITLE>\n";
    print "<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"".$configure->refreshtime()."\"; URL=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."?status=startppp2\">\n";
    print "</HEAD>\n<BODY BGCOLOR=\"".$configure->bgcolor()."\">\<H1>$message[18]</H1>\n</BODY>\n</HTML>\n";
  }
}
sub printFound{
  print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
  print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n";
  print "<B>$message[19]</B>";
  print "</CENTER></TD></TR><TR BGCOLOR=\"".$configure->tablecolor()."\"><TD>";
  #print "<H5>$message[21]</H5>\n";
  #with Suse 6.4 use here  `/sbin/ifconfig -l $dev`
  my $dev = $configure->dev();
  @pppip = `/sbin/ifconfig $dev`;
  @colsplit = split(":",$pppip[1]);
  @inetarr = split(" ", $colsplit[1]);
  print "<P>\n$message[22]\n $inetarr[0]\n</P>\n";
  @inetarr = split(" ", $colsplit[2]);
  print "<P>\n$message[23]\n $inetarr[0]\n</P>\n";
  print "<P>\n$message[24]\n $colsplit[3]\n</P>\n";
  print "</TD></TR></TABLE></TD></TR></TABLE>";
}
# Abwahl *****************************************
sub stopppp{
  $found = 0;
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    my $dev = $configure->dev();
    if(($addr =~ /$dev/) && ($configure->type() ne 2)){
      $found = 1; # Verbindung noch da
    }
  }
  if ($configure->type() eq 2) {
    $found = 1;
    if ($configure->isdnip()){
      foreach $addr (@pppaddr){
        my $isdnip = $configure->isdnip();
        if($addr =~ /$isdnip/){
          $found = 0;
        }
      }
    }
  }
  &online;
  if (!($istonline)){
    &error($message[25]);
    exit;
  }
  open (LOG, ">>online.log");
  open (ONLINE, ">online.dat");
  if ($found){
    $eintrag = 0;
    foreach $ip (@online){
      if (!($ip =~ /$myip/)){
        if (!($ip =~ /^$/)){
          print ONLINE $ip."\n";
        }
      }else{
        $eintrag = 1;
        @zeile = split(/\e/,$ip);
        print LOG $myip."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
      }
    }
    if ($eintrag == 0){
      @zeile = split(/\e/,$ip);
      print LOG $myip."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
    }
  }else{
    foreach $ip (@online){
      @zeile = split(/\e/,$ip);
      print LOG $zeile[0]."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
    }
  }
  close (LOG);
  close (ONLINE);
  &online;
  if (!(@online)){
    system($configure->run_dialout()." &");
    if ($configure->type() eq 0){
      `/usr/bin/killall wvdial`;
    }elsif ($configure->type() eq 2){
      my $deconnectcommand = $configure->deconnectcommand();
      `$deconnectcommand`;
    }
    if ($configure->type() ne 2){
      `killall pppd`;
      my $dev = $configure->dev();
      `/sbin/ifconfig $dev down`;
    }
    @pppaddr = `/sbin/ifconfig`;
    &bytes(0);
    open (traffic, ">>traffic.log");
      print traffic $receive."\e".$transmit."\e".$time."\eprog\n";
    close (traffic);
    open (pid, "<".$configure->webdialpid()) || die("can't access ".$configure->webdialpid().": $!");
      $pid = <pid>;
    close (pid);
    system ("kill", "$pid");
    system ("rm",$configure->webdialpid());
  }
  &buttons($message[26]);
  &onlinestat;
  &configure;
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    my $dev = $configure->dev();
    if(($addr =~ /$dev/) && ($configure->type() ne 2)){
      $found = 1;
    }
  }
  if ($configure->type() eq 2) {
    $found = 1;
    if ($configure->isdnip()){
      foreach $addr (@pppaddr){
        my $isdnip = $configure->isdnip();
        if($addr =~ /$isdnip/){
          $found = 0;
        }
      }
    }
  }
  if ($found){
    &printFound;
  }
  print end_html;
}
sub config{
  &buttons($message[4]);
  &configure;
  open (provider, "<provider.dat");
    @provider = <provider>;
  close provider;
  chop @provider;
    
  if ((param('pass') eq $configure->configpass()) || (param('pass') eq $configure->adminpass()) || (!$configure->configpass())){
    if (param('status2') eq "change"){&configchange}
  }
  if ((param('pass') eq $configure->adminpass()) || (!$configure->adminpass())){
    if (param('status2') eq "sub"){&configsub}
    if (param('status2') eq "add"){&configadd}
  }
  foreach $name (@provider){
    @liste = split /\e/,$name;
    push @alleprovider, $liste[0];
  }

  print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
  print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n";
  print "<B>$message[4]</B>";
  print "</CENTER></TD></TR><TR BGCOLOR=\"".$configure->tablecolor()."\"><TD>";
      
  print start_form;
  print popup_menu(-name=>'providername',-values=>\@alleprovider);
  print "<INPUT type=hidden name=\"status\" value=\"config\">\n";
  print "<INPUT type=hidden name=\"status2\" value=\"change\">\n";
  if ($configure->configpass()){
    print "<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
  }
  print submit($message[27]);
  print end_form;
  print start_form;
  print popup_menu(-name=>'providername',-values=>\@alleprovider);
  print "<INPUT type=hidden name=\"status\" value=\"config\">\n";
  print "<INPUT type=hidden name=\"status2\" value=\"sub\">\n";
  if ($configure->adminpass()){
    print "<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
  }
  print submit($message[28]);
  #print "<HR>\n";
  print end_form;
  print start_form,"\n<TABLE>\n<TR>\n<TD>\n",
	  "\t<TABLE>\n\t<TR>\n\t<TD>$message[29]</TD>\n\t<TD>\n\t",textfield('providername'),"</TD>\n\t</TR>\n\t",
	  "<TR>\n\t<TD>$message[12]</TD>\n\t<TD>",textfield('nummer'),"</TD>\n\t</TR>\n\t",
	  "<TR>\n\t<TD>$message[13]</TD>\n\t<TD>",textfield('login'),"</TD>\n\t</TR>\n\t",
	  "<TR>\n\t<TD>$message[14]</TD>\n\t<TD>\n\t",password_field('password')."\n\t",
	  "<INPUT type=hidden name=\"status\" value=\"config\">\n\t",
	  "<INPUT type=hidden name=\"status2\" value=\"add\">\n\t",
	  "</TD>\n\t</TR>\n\t</TABLE>\n</TD>\n<TD>\n";
  if ($configure->adminpass()){
    print "<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
  }
  print submit(-name=>'submit',-value=>"$message[35]"),"\n</TD>\n</TR>\n</TABLE>\n",end_form;
  print "</TD></TR></TABLE></TD></TR></TABLE>";
  print end_html;
}
sub configchange{
  $pro = (param('providername'));
  foreach $change (@provider){
    if ($change =~ /$pro/){
      @info = split(/\e/,$change);
      open (con, "</etc/wvdial.conf");
      @con = <con>;
      chop @con;
      close (con);
      open(out, ">/etc/wvdial.conf");
      foreach $va (@con){
	if ($va =~ /Username/){
	  print out "Username = ".$info[2]."\n";
	}
	elsif ($va =~ /Password/){
	  print out "Password = ".$info[3]."\n";
	}
	elsif ($va =~ /Phone/){
	  print out "Phone = ".$info[1]."\n";
	}
	elsif ($va =~ /Provider/){
	  print out "Provider = ".$info[0]."\n";
	}else{
	  print out $va."\n";
        }
      }
      close out;
    }
  }
}

sub configsub{
  $pro = (param('providername'));
  open (in, "<provider.dat");
    @in = <in>;
  close in;
  chop @in;
  open (out, ">provider.dat");
  foreach $sub (@in){
    @info1 = split(/\e/,$sub);
    if (!($pro eq $info1[0])){
      print out $sub."\n";
    }
  }
  close out;
  open (provider, "<provider.dat");
    @provider = <provider>;
  close provider;
  chop @provider;
}

sub configadd{
  $pro = (param('providername'));
  open (out, ">>provider.dat");
    print out (param('providername'))."\e".(param('nummer'))."\e".(param('login'))."\e";
    print out (param('password'))."\n";
  close out;
  open (provider, "<provider.dat");
    @provider = <provider>;
  close provider;
  chop @provider;
}

sub logs{
  &buttons($message[5]);
  print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
  print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n";
  print "<B>$message[5]</B>";
  print "</CENTER></TD></TR><TR><TD>";
  if ((!($configure->logpass())) || ( (param('pass') eq $configure->logpass())) || (param('pass') eq $configure->adminpass())){
    open (in, "<online.log");
      @in = <in>;
    close in;
    chop @in;
    if (param('status2') eq "list"){
      $rechnerip =(param('rechner'));
      
      print "<PRE>\n";
      $gesamt = 0;
      $rechner = 0;
      my $vontag = int (param('vontag'));
      my $vonmon = int (param('vonmon'))-1;
      my $vonjahr= int (param('vonjahr'))-1900;
      my $vontime= Time::Local::timelocal(0,0,0,$vontag,$vonmon,$vonjahr);
      my $bistag = int (param('bistag'));
      my $bismon = int (param('bismon'))-1;
      my $bisjahr= int (param('bisjahr'))-1900;
      my $bistime= Time::Local::timelocal(59,59,23,$bistag,$bismon,$bisjahr);
      foreach $l (@in){
  	if (($l =~ /^${rechnerip}/) || ($rechnerip eq "")){
          @zeile = split(/\e/,$l);
  	  if ($zeile[1] == 1){
	    if ($rechner == 0){
	      $rechner = $rechner + 1;
	      $on = $zeile[3];
	    }else{
	      $rechner = $rechner + 1;
	    }
	  }else{
	    $rechner = $rechner - 1;
	    $off = $zeile[3];
	  }
	  
	  if (($zeile[3] > $vontime) && ($zeile[3] < $bistime)){
	  
	  
	    if ($zeile[1] eq 0){
	      if ($rechner eq 0){
	        $diff = $off - $on;
	        $gesamt = $gesamt + $diff;
	        &wann($diff-3600*$configure->timezone());
	        print "<FONT COLOR=\"".$configure->colordeconnect()."\"><B>".$zeile[0]."\t ".$zeile[2]."\t$message[34]&nbsp;".$std.":".$min.":".$sec."</B></FONT>\n";
	      }else{
	        print "<FONT COLOR=\"".$configure->colordeconnect()."\"><B>".$zeile[0]."\t ".$zeile[2]."</B></FONT>\n";
	      }
	    }else{
	      print "<FONT COLOR=\"".$configure->colorconnect()."\"><B>".$zeile[0]."\t ".$zeile[2]."\t$message[49]&nbsp;".$zeile[4]."</B></FONT>\n";
	    }
	  }
        }
      }
      ($sec, $min, $std, $tag) = localtime($gesamt-3600*$configure->timezone());
      $sec = &zs($sec);
      $min = &zs($min);
      $std = &zs($std+(($tag-1)*24));
      print "\n";
      print "<FONT COLOR=\"".$configure->gesamtcolor()."\"><B>$message[30] ".$std.":".$min.":".$sec."</B></FONT>\n";
      print "</PRE>\n";
      print "<FORM ACTION=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" METHOD=\"post\">\n<TABLE>\n<TR>\n<TD>\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status2\" VALUE=\"traffic\">\n";
      if ($configure->logpass()){
        print "<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
      }
      &logvon;
      &logbis;
      print "</TD></TR><TD><INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[43]\">\n";
      print "\n</TD>\n</TR>\n</TABLE>\n</FORM>";
    }elsif (param('status2') eq "traffic"){
      open (traffic, "<traffic.log");
        @traffic = <traffic>;
      close traffic;
      print "<TABLE border=\"0\">\n";
      my $ages = 0;
      my $bges = 0;
      my $vontag = int (param('vontag'));
      my $vonmon = int (param('vonmon'))-1;
      my $vonjahr= int (param('vonjahr'))-1900;
      my $vontime= Time::Local::timelocal(0,0,0,$vontag,$vonmon,$vonjahr);
      my $bistag = int (param('bistag'));
      my $bismon = int (param('bismon'))-1;
      my $bisjahr= int (param('bisjahr'))-1900;
      my $bistime= Time::Local::timelocal(59,59,23,$bistag,$bismon,$bisjahr);
      foreach $i (@traffic){
        if (!($i =~ /\e$/)){
	   @zeile = split("\e", $i);
	  &wann($zeile[0]);
	  $ein = $datum;
	  &wann($zeile[3]);
	  $a = (int $zeile[1]/1024);
	  $b = (int $zeile[2]/1024);
	  if (($zeile[0] > $vontime) && ($zeile[0] < $bistime)){
	  print "<TR>\n<TD ALIGN=\"right\"><B>".&punkte($a)."</B></TD>\n";
	  print "<TD>kB&nbsp;$message[41]</TD>\n";
	  print "<TD ALIGN=\"right\"><B>".&punkte($b)."</B></TD>\n";
	  print "<TD>kB&nbsp;$message[42]</TD>\n";
	  print "<TD>&nbsp;&nbsp;</TD>\n";
	  print "<TD><FONT COLOR=\"".$configure->colorconnect()."\"><B>".$ein."</B></FONT></TD>\n";
	  print "<TD><FONT COLOR=\"".$configure->colordeconnect()."\">&nbsp;<B>$datum</B></FONT></TD>\n";
	  print "</TR>\n";
	  $ages += $a;
	  $bges += $b;
	}
	} 
      }
      print "<TR><TD>&nbsp;<TD></TR>";
      print "<TR>\n<TD ALIGN=\"right\"><B>".&punkte($ages)."</B></TD>\n";
      print "<TD>kB&nbsp;$message[41]</TD>\n";
      print "<TD ALIGN=\"right\"><B>".&punkte($bges)."</B></TD>\n";
      print "<TD>kB&nbsp;$message[42]</TD>\n";
      print "<TD>&nbsp;&nbsp;</TD>\n";
      print "</TABLE>";
       
      print "<FORM ACTION=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" METHOD=\"post\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status2\" VALUE=\"list\">\n<TABLE>\n<TR>\n";
      if ($configure->logpass()){
        print "<TD>\n<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n</TD>";
      }
      print "<TD>\n";
      &logvon;
      &logbis;
      print "</TD></TR><TD><INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[36]\">\n</TD>\n";
      print "\n</TD>\n</TR>\n</TABLE>\n</FORM>";
    
    }else{
      # IP's aller geloggten Rechner ermitteln
      undef @ips;
      foreach $l (@in){
        @zeile = split(/\e/,$l);
        push @ips, $zeile[0];
      }
      push @allip, $ips[0];
      foreach $i (@ips){
        for ($j=0;$j<$#allip+1;$j++){
          if ($allip[$j] eq $i) {last;}
	  if ($j == $#allip){
	    push @allip, $i;
	  }
        } 
      }
      undef $time;
      foreach $ip (@allip){
        foreach $l (@in){
	  @zeile = split(/\e/,$l);
	  if (($zeile[1] eq 0) && ($zeile[0] eq $ip)){
	    $time += $zeile[3] - $zeile[4];
	  }
        }
        push @iptime,$time;
        undef $time;
      }
      foreach $t (@iptime){
        $all += $t;
      }
      print "<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
      print "<INPUT type=hidden name=\"status\" value=\"log\">\n";
      print "<INPUT type=hidden name=\"status2\" value=\"list\">\n";
      print "<TABLE BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n";
      for ($i=0;$i<$#allip+1;$i++){
        if ($all){
          #$x = sprintf("%.0f",($iptime[$i]/$all*100));
          $x = int ($iptime[$i]/$all*100);
	}else{
	  $x=0;
	}
	print "<TR>\n<TD>\n";
        print "<INPUT TYPE=\"radio\" NAME=\"rechner\" VALUE=\"$allip[$i]\">\n<TT>$allip[$i]</TT>\n&nbsp;&nbsp;</TD>\n";
        print "<TD ALIGN=\"LEFT\">\n<IMG SRC=\"".$configure->baseURL().$configure->htmlDIR()."1.gif\" WIDTH=\"3\" HEIGHT=\"10\" BORDER=\"0\">";
        print "<IMG SRC=\"".$configure->baseURL().$configure->htmlDIR()."2.gif\" WIDTH=\"".4*$x."\" HEIGHT=\"10\" BORDER=\"0\">";
        print "<IMG SRC=\"".$configure->baseURL().$configure->htmlDIR()."3.gif\" WIDTH=\"4\" HEIGHT=\"10\" BORDER=\"0\">\n&nbsp;\n</TD>\n<TD>\n";
        print "<TT>${x}%</TT>\n</TD>\n</TR>\n";
      }
      print "<TR>\n<TD>\n<INPUT TYPE=\"radio\" NAME=\"rechner\" VALUE=\"\">\n<TT>$message[5]</TT>\n</TD>\n";
      print "</TABLE>\n";
      print "<TABLE>\n<TR>\n";
      if ($configure->logpass()){
        print "<TD>\n<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n</TD>\n";
      }
      &logvon;
      &logbis;
      print "<TD>\n<INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[36]\">\n";
      print "</TD></TR></TABLE>\n</FORM>\n";
      print "<FORM ACTION=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" METHOD=\"post\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status2\" VALUE=\"traffic\">\n<TABLE>\n<TR>\n";
      if ($configure->logpass()){
        print "<TD>\n<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n</TD>";
      }
      print "<TD>\n";
      &logvon;
      &logbis;
      print "</TD></TR><TR><TD><INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[43]\">\n</TD>\n";
      print "\n</TD>\n</TR>\n</TABLE>\n</FORM>";
    }
    #&logbuttons;
    print end_html;
  }else{
    print start_form;
    print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
    print "<FONT COLOR=\"".$configure->passwordcolor()."\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
    print submit($message[5]);
    print end_form;
    print end_html;
  }
  print "</TD></TR></TABLE></TD></TR></TABLE>";
}
sub logvon{
  ($vtag, $vmonat, $vjahr)=(localtime(time-($configure->standardlogdays()*86400)))[3,4,5];
  $vmonat = $vmonat+1;
  $vjahr  = $vjahr+1900;
  print "<TT>$message[47]</TT>";
  print "<select name=\"vontag\">";
  for (my $i=1;$i<32;$i++){
    print "<option ";
    if ($i == $vtag){print " selected";}
    $i = &zs($i);    
    print ">$i</option>";
  }
  print "</select>";
  print "<select name=\"vonmon\">";
  for (my $i=1;$i<13;$i++){
    print "<option ";
    if ($i == $vmonat){print " selected";}
    $i = &zs($i);    
    print ">$i</option>";
  }
  print "</select>";
  print "<select name=\"vonjahr\">";
  for (my $i=2000;$i<2005;$i++){
    print "<option ";
    if ($i == $vjahr){print " selected";}
    $i = &zs($i);    
    print ">$i</option>";    
  }
  print "</select><BR>";
  
}
sub logbis{
  ($tag, $monat, $jahr)=(localtime(time))[3,4,5];
  $monat = $monat+1;
  $jahr  = $jahr+1900;
  print "<TT>$message[48]</TT>";
  print "<select name=\"bistag\">";
  for (my $i=1;$i<32;$i++){
    print "<option ";
    if ($i == $tag){print " selected";}
    $i = &zs($i);
    print ">$i</option>";
  }
  print "</select>";
  print "<select name=\"bismon\">";
  for (my $i=1;$i<13;$i++){
    print "<option";
    if ($i == $monat){print " selected";}
    $i = &zs($i);
    print ">$i</option>";
  }
  print "</select>";
  print "<select name=\"bisjahr\">";
  for (my $i=2000;$i<2005;$i++){
    print "<option";
    if ($i == $jahr){print " selected";}
    $i = &zs($i);
    print ">$i</option>";
  }
  print "</select>";
}
sub punkte{  my $ages = $_[0];
  my $a = int length($ages)/3;
  my $ahelp;
  for ($i=$a;$i>0;$i--){
    $ahelp = $ahelp.".".substr($ages,-($i*3),3);
  }
  $ahelp = substr($ages,0,(length($ages)-($a*3))).$ahelp;
  if ((length($ages)-($a*3)) == 0){
    $ahelp = substr($ahelp,1);
  }
  return $ahelp;
}
sub status{
    @pppaddr = `/sbin/ifconfig`;
    &buttons($message[6]);
    print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
    print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n";
    print "<B>$message[6]</B>";
    print "</CENTER></TD></TR><TR><TD>";
    print "<PRE>";
    foreach $ppp (@pppaddr){
	print $ppp,"";
    }
    print "</TD></TR></TABLE></TD></TR></TABLE>";
    print end_html;
}

# ************************************************
sub logbuttons{
  print "\t<!-- Begin der LogButtons -->\n";
  if ($configure->varlogbuttons()){
    #print "<HR>\n";
    print "<TABLE>\n<TR>\n";
	&messagesbutton;
	&httpebutton;
    print "</TR>\n</TABLE>\n";
  }
  print "\t<!-- Ende der LogButtons -->\n";
}
sub messagesbutton{
    print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
    print "<INPUT type=hidden name=\"status\" value=\"messages\">\n";
    print "<INPUT type=submit name=submit value=\"$message[31]\">\n";
    print "</FORM>\n</TD>\n";
}
sub httpebutton{
    print "<TD>\n<FORM action=\"".$configure->baseURL().$configure->baseCGI()."/".$configure->skript()."\" method=\"post\">\n";
    print "<INPUT type=hidden name=\"status\" value=\"httpe\">\n";
    print "<INPUT type=submit name=submit value=\"$message[32]\">\n";
    print "</FORM>\n</TD>\n";
}
sub messages{
    &buttons($message[31]);
    undef @in;
    open (in, "<".$configure->messageslog());
	my @in = <in>;
    close (in);
    chop @in;
    print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
    print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n<B>";
    print "$message[44]";
    print "</CENTER></TD></TR><TR><TD>";
    print "<PRE>";
    my $loglines = $configure->loglines();
    for ($i = 1;$i<=$loglines;$i++){
      print $in[-$i]."\n";
    }
    undef @in;
    print "</TD></TR></TABLE></TD></TR></TABLE>";
    print end_html;
}
sub httpe{
    &buttons($message[33]);
    undef @in;
    open (in, "<".$configure->errorlog());
	@in = <in>;
    close (in);
    chop @in;
    print "<TABLE BGCOLOR=\"".$configure->bordercolor()."\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"".$configure->tablecolor()."\">\n";
    print "<TR BGCOLOR=\"".$configure->titlecolor()."\">\n<TD><CENTER>\n<B>";
    print "$message[45]";
    print "</CENTER></TD></TR><TR><TD>";
    print "<PRE>";
    my $loglines = $configure->loglines();
    for ($i = 1;$i<=$loglines;$i++){
      print $in[-$i]."\n";
    }
    undef @in;
    print "</TD></TR></TABLE></TD></TR></TABLE>";
    print end_html;
}
sub error{
    print header;
    print "<HEAD>\n<TITLE>".@_[0]."</TITLE>\n</HEAD>\n";
    print "<BODY BGCOLOR=\"".$configure->bgcolor()."\">\n";
    print "<H2>".@_[0]."</H2>\n</BODY>\n</HTML>";
    exit;
}

sub allowed{
  foreach $i (@notallow){
    if ($myip eq $i){
      &error($message[38]);
    }
  }
}
sub by{
  print "<A HREF=\"http://www.pegestorf.de/webwvdial\"><FONT COLOR=\"#114311\" STYLE=\"text-decoration:none\"><B>WebDialer 1.3</B></FONT></A>";
  print "<FONT >\n&copy;&nbsp;2000-2001&nbsp;by&nbsp;\n<A HREF=\"mailto:dietrich\@pegestorf.de\">\n";
  print "<FONT COLOR=\"#114311\" STYLE=\"text-decoration:none\"><B>Dietrich&nbsp;Heise</B></FONT></A>\n</FONT>\n";
}

sub bytes{
  my $help = $_[0];
  @bytes = `cat /proc/net/dev`;
  foreach $i (@bytes){
    my $dev = $configure->dev();
    if($i =~ /$dev/){
      my @help1 = split(":",$i);
      my @help2 = split(" ",$help1[1]);
      if ($help){
        $receive = sprintf ("%d\n",($help2[0]/1024));
        $transmit= sprintf ("%d\n",($help2[8]/1024));
      }else{
        $receive = $help2[0];
        $transmit= $help2[8];
      }
      if ($help){
        print "<TABLE>\n\<TR>\n<TD>\n";
	print "<U>$message[46]</U></TD>\n</TR>\n</TABLE>";
	print "<TABLE>\n\<TR>\n<TD ALIGN=\"right\">${receive}</TD>\n<TD>kB&nbsp;$message[41]</TD>\n</TR>\n";
        print "<TR>\n<TD ALIGN=\"right\">${transmit}</TD>\n<TD>kB&nbsp;$message[42]</TD>\n</TR>\n</TABLE>\n";
      }
    }
  }
}

sub ifpppdown{
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    my $dev = $configure->dev();
    if(($addr =~ /$dev/) && (!($configure->isdnip()))){
      return; # Verbindung noch da
    }
  }
  if ($configure->type() eq 2) {
    $isdn = 1;
    if ($configure->isdnip()){
      foreach $addr (@pppaddr){
        my $isdnip = $configure->isdnip();
        if($addr =~ /$isdnip/){
          $isdn = 0;
        }
      }
    }
    if ($isdn) {return;}
  }
  # Verbindung nicht da!
  open (LOG, ">>online.log");
  open (ONLINE, ">online.dat");
  foreach $ip (@online){
    @zeile = split(/\e/,$ip);
    print LOG $zeile[0]."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
  }
  close (LOG);
  close (ONLINE);
}
sub readconfig{
  open(CONFIG, "webdial.conf") || &cantopenconfig;
  my $key;
  my $number;
  my $line;
  while (<CONFIG>) {
    $line = $_;
    chomp $line;
    if ((!(/^#/)) && (/=/))  {
      ($key,$number) = (split(/=/,$line));
      $config{$key} = $number;
    }
  }
  close (CONFIG);
}  
sub cantopenconfig{
  print header;
  print "Can't open Config File";
  exit;
}

sub german{
@message = ("Internet Status",
	    "Verbindung starten",
	    "Verbindung trennen",
	    "Herunterfahren",
	    "Konfigurieren",
	    "Logs einsehen",
	    "Online Status",
	    "Informationen",
	    "zur Zeit sind folgende Rechner Online :",
	    "Niemand online",
	    "folgende Verbindung ist eingestellt:", #10
	    "Provider",#11
	    "Telefonnummer",#12
	    "Username",#13
	    "Passwort",
	    "Der Rechner wird herruntergefahren",
	    "ERROR!! Dieser Rechner ist schon online",
	    "Verbindung hergestellt",
	    "Eine Internetverbindung wird hergestellt.",
	    "Eine Internetverbindung wurde hergestellt",
	    "viel Spass beim Surfen",#20
	    "Deine Addresse ist:",
	    "Internet IP Addresse:",
	    "Point-to-Point IP Address:",
	    "Net Mask IP Address:",
	    "ERROR!! Sie sind nicht online!",
	    "Internet Abwahl",
	    "Provider benutzen",
	    "Entfernen",
	    "Provider Bezeichnung",
	    "Gesamte Onlinezeit: ",#30
	    "Messages",
	    "Http Error",
	    $configure->errorlog(),
	    "Onlinezeit:",
	    "Hinzufuegen",
	    "Liste",#36
	    "Statistik",
	    "Zugriff von dieser IP Addresse nicht erlaubt",
	    "Passwort:",
	    "Eine ADSL Verbindung ist eingestellt", #40
	    "empfangen",#41
	    "gesendet",#42
	    "Datenvolumen",#43
	    "lezten ".$configure->loglines()." Zeilen der ".$configure->messageslog()." (von neu nach alt)",#44
	    "lezten ".$configure->loglines()." Zeilen der ".$configure->errorlog()." (von neu nach alt)",#45
	    "Datentransfer seit letztem Verbindungsaufbau:",#46
	    "vom&nbsp;",#47
	    "bis&nbsp;",
	    "IP:");
}
sub english{
@message = ("Internet state",
	    "Connect",
	    "Disconnect",
	    "Shutdown",
	    "Configure",
	    "Logs",
	    "Online state",
	    "Information",
	    "the following computers are online:",
	    "no one online",
	    "The following connection will be used:",  #10
	    "Provider",
	    "Phone number",
	    "User name",
	    "Password",
	    "Shutdown...",
	    "ERROR!! Your computer is already online",
	    "Connection estabished",
	    "A connection is being established",
	    "Connection established",
	    "have fun",                                #20
	    "Your addresse is:",
	    "Internet IP address:",
	    "Point-to-Point IP address:",
	    "Net Mask IP address:",
	    "ERROR!! Your computer is not online!",
	    "Internet disconnect",
	    "Use provider",
	    "Delete",
	    "Provider name",
	    "Total online time: ",                      #30
	    "Messages",
	    "Http Error",
	    $configure->errorlog(),
	    "Online time:",
	    "Add",                                     #35
	    "List",
	    "Statistics",
	    "Connection not allowed for this IP Address",
	    "Password:",
	    "An ADSL Connection is Configured",#40
	    "received",#41
	    "sent",#42
	    "Traffic",#43
	    "Last ".$configure->loglines()." lines of ".$configure->messageslog()." (form new to old)",#44
	    "Last ".$configure->loglines()." lines of ".$configure->errorlog()." (form new to old)",#45
	    "Data transferred since last connect:",
	    "from&nbsp;",
	    "till&nbsp;",
	    "IP:");
}

sub francais{
#thanks to jerome ROUER 
@message = ("Statut Internet",
  "Connexion",
  "Dconnexion",
  "Couper",
  "Configurer la connexion",
  "Logs & stats",
  "Statut des interfaces (ifconfig)",
  "Informations",
  "Les ordinateurs suivants sont en ligne :",
  "Aucun n'est en ligne",
  "Sauf autre choix, la configuration de connexion suivante va tre utilise :",  #10
  "Fournisseur d'Accs Internet (FAI) : ",
  "Numro de tlphone de ce FAI :",
  "Nom utilisateur chez le FAI",
  "Mot de passe chez le FAI",
  "Arrter/couper la connexion...",
  "ERREUR!! Votre ordinateur est dj` connect",
  "Connexion tablie",
  "Tentative de connexion en cours...",
  "Connexion tablie avec succs...",
  "Bonne navigation sur le Web...",                                #20
  "Votre adresse est :",
  "Adresse Internet donne par le FAI pour cette connexion :",
  "Adresse IP Point-to-Point du FAI pour cette connexion :",
  "Net Mask IP addresse :",
  "ERREUR!! Votre ordinateur n'est pas en ligne!",
  "Internet et tlphone dconnects.",
  "Utiliser cette connexion",
  "Effacer cette configuration",
  "Nom du FAI",
  "Temps total sous connexion (hh:mm:ss) : ",                      #30
  "Messages systme",
  "Fichiers des erreurs Http",
  $configure->errorlog(),
  "Temps de connexion :",
  "Ajouter cette configuration ",                                     #35
  "Voir les statistiques de connexion",
  "Rafrachir les fichiers de Logs",
  "Connexion non autorise pour l'adresse IP de cet ordinateur!",
  "Mot de passe pour  ", 
  "Une connexion d'cAdsl est configuree", #40
  "recu",#41
  "envoient",#42
  "Le trafic",#43
  "dernieres ".$configure->loglines()." lignes de ".$configure->messageslog()." (formez nouveau a vieux)",#44
  "dernieres ".$configure->loglines()." lignes de ".$configure->errorlog()." (formez nouveau a vieux)",#45
  "les donnees ont transfere puisque dernier reliez:",
  "de&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
  "jusqu' a;&nbsp;",
  "IP:");
}
sub spanish{
# by Diego Gonella
# gonelladiego@ciudad.com.ar
@message = ("Estado de Internet",
    "Conectar",
    "Desconectar",
    "Apagar",
    "Configurar",
    "Registros",
    "Estado Online",
    "Informacion",
    "Computadoras estan online :",
    "ninguna",
    "La siguiente conexion podria ser usada:",  #10
    "Proveedor",
    "Numero de Telefono",
    "Usuario",
    "Password",
    "Apagando...",
    "ERROR!! La Computadora aun esta Online!",
    "Conexion establecida",
    "Intentando establecer la conexion.",
    "Conexion establecida",
    "Diviertase",                                #20
    "Su direccion de IP es:",
    "Direccion de Internet IP:",
    "Point-to-Point IP address:",
    "Net Mask IP address:",
    "ERROR!! Su Computadora no esta Online!",
    "Internet deconnect",
    "Usar proveedor",
    "Borrar",
    "Nombre del Proveedor",
    "Total de tiempo Online: ",                      #30
    "Mensajes",
    "Errores Http",
    $configure->errorlog(),
    "Tiempo Online:",
    "Agregar",                                     #35
    "Listado",
    "Estadisticas",
    "La conexion no esta permitida desde esta IP",
    "Password:",
    "A ADSL Connection is Configured",#40
    "Recibidos",#41
    "Enviados",#42
    "Trafico",#43
    "Ultimas ".$configure->loglines()." lineas de ".$configure->messageslog()." (de nuevos a viejos)",#44
    "Ultimas ".$configure->loglines()." lineas de ".$configure->errorlog()." (de nuevos a viejos)",#45
    "Datos transferidos desde la ultima conexion:",
    "de&nbsp;&nbsp;&nbsp;&nbsp;",
    "hasta&nbsp;",
    "IP:");
}
sub italian{
#by Federico Pedemonte
#fepede@iol.it
@message = ("Stato di internet",
        "Connetti",
	"Disconnetti",
        "Spegni",
        "Configura",
        "Logs",
        "Stato dell'interfaccia (ifconfig)",
        "Informazioni",
        "I seguenti computer sono online :",
        "Nessun computer online",
	"Verra usata questa connessione:",  #10
        "Provider",
        "Numero di telefono",
        "Username",
        "Password",
        "Shutdown...",
        "ERRORE!! Il tuo computer e' gia' online !",
        "Connessione effettuata",
        "Sto effettuando la connessione.",
        "Connessione effettuata",
        "Buon divertimento !",                                #20
        "Il tuo indirizzo ip e':",
        "Indirizzo IP:",
        "Indirizzo Point-to-Point IP:",
        "Net Mask IP address:",
        "ERRORE!! Il tuo computer non e' online !",
        "Disconnesso da Internet",
        "Usa provider",
        "Cancella",
        "Nome provider",
        "Tempo totale online: ",                      #30
        "Messaggi",
        "Errori http",
        $configure->errorlog(),
        "Tempo online:",
        "Aggiungi",                                     #35
        "Lista",
        "Statistiche",
        "Connessione non autorizzata per questo IP",
        "Password:",
        "E' configurata una connessione ADSL",#40
        "Ricevuti",#41
        "Inviati",#42
        "Traffico",#43
        "Ultime ".$configure->loglines()." linee di ".$configure->messageslog(),#44
        "Ultime ".$configure->loglines()." linee of ".$configure->errorlog(),#45
        "Dati trasferiti nell'ultima connessione:",
	"da&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
	"lavorara a",
	"IP:");
}

#by Ladislav Zahour
#zahour@zah.cz
sub czech{
@message = ("Stav internetu",
	    "Pipojit",
	    "Odpojit",
	    "Vypni",
	    "Konfigurovat",
	    "Protokol",
	    "Aktuln stav",
	    "Informace",
	    "nsledujc potae jsou pipojeny :",
	    "no one online",
	    "nasledujc pipojen jsou vyuita:",  #10
	    "Provider",
	    "Telefonn slo",
	    "Uivatel",
	    "Heslo",
	    "Vypnm...",
	    "ERROR!! V pota je pipojen",
	    "Spojen navzno",
	    "Spojen bude vytvoeno.",
	    "Spojen vytvoeno",
	    "uijte si",                                #20
	    "Vae adresa je:",
	    "Internet IP adresa:",
	    "Point-to-Point IP adresa:",
	    "Net Mask IP address:",
	    "ERROR!! V pota nen pipojen!",
	    "Internet deconnect",
	    "Use provider",
	    "Zru",
	    "Provider",
	    "Celkov as pipojen: ",                      #30
	    "Prva",
	    "Http Error",
	    $configure->errorlog(),
	    "as pipojen:",
	    "Pidej",                                     #35
	    "Seznam",
	    "Statistika",
	    "Pipojen nen povoleno pro tuto IP adresu",
	    "Heslo:",
	    "ADSL pipojen je konfigurovno",#40
	    "pjem",#41
	    "vysln",#42
	    "Provoz",#43
	    "posledni ".$configure->loglines()." lines of ".$configure->messageslog()." (od nejnovjch ke starm)",#44
	    "posledn ".$configure->loglines()." lines of ".$configure->errorlog()." (od nejnovjch ke starm)",#45
	    "penesen data od poslednho spojen:",
	    "od&nbsp;",
	    "do&nbsp;",
	    "IP:");
}

#by Devrim Erdem
#devrim@kodusta.com
sub turkish{
@message = ("Internet durumu",
            "Baglan",
	    "Baglantiyi kopar",
	    "Kapat",
	    "Ayarlar",
	    "Kayitlar",
	    "Baglanti durumu",
	    "Bilgi",
	    "Asagidaki bilgisayarlar baglidir:",
	    "hic kimse bagli degil",
	    "Asagidaki baglanti kullanilacak:",  #10
	    "Servis Saglayici",
	    "Telefon Numarasi",
	    "Kullanici Ismi",
	    "Sifre",
	    "Kapat...",
	    "HATA!! Bilgisayariniz bagli degil !",
	    "Baglanti saglandi",
	    "Baglanti saglaniyor",
	    "Baglanti saglandi",
	    "Keyfinize bakin",
	    "Adresiniz:",
	    "Internet IP adresi:",
	    "Point-to-Point IP adresi:",
	    "Net Mask IP adresi:",
	    "HATA!! Bilgisayariniz bagli degil !!",
	    "Internet Kopar",
	    "Bu Servis saglayiciyi kullan",
	    "Sil",
	    "Servis Saglayaci Ismi",
	    "Toplam baglanti suresi: ",#30
	    "Mesajlar",
	    "Http Hatalari",
	    $configure->errorlog(),
	    "Baglati suresi:",
	    "Ekle",
	    "Listele",
	    "Istatistikler",
	    "Bu IP adresi icin baglantiya izin verilmiyor.",
	    "Sifre:",
	    "ADSL baglantisi configure edildi.",#40
	    "alindi",#41
	    "gonderildi",#42
	    "Trafik",#43
	    "Son ".$configure->loglines()." satir ".$configure->messageslog()." (yeniden eskiye dogru)",#44
	    "Son ".$configure->loglines()." satir ".$configure->errorlog()." (yeniden eskiye dogru)",#45
	    "Son baglantidan beri transfer edilen data :",
	    "'dan beri&nbsp;",
	    "'a kadar&nbsp;",
	    "IP:");
}
